<?php
/**
 * Created by JetBrains PhpStorm.
 * User: ArturMarcos
 * Date: 11/05/17
 * Time: 17:34
 * To change this template use File | Settings | File Templates.
 */

namespace HCM\FPA\Calculos\Apolo;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Calculos\Geral\Inicializa;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\FPA\Calculos\Apolo\ExportacaoConsumer;

class MigracaoFilaApolo extends \Zeedhi\Queue\Producer{
    
    protected static $queueName = "/queue/";

// apollo port browser = 61680
    const LIMIT_LOTE_FOUR = 4;
    const LIMIT_LOTE_ONE = 1;

    public function __construct($entityManager, $hcmParameters, $dataSet){
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        
        $paramsApolo = FPA::getParamsApolo();
        
        $url = $paramsApolo['URL'];
        $port = $paramsApolo['PORT'];
        $user = $paramsApolo['USER'];
        $password = $paramsApolo['PASSWORD'];
        $broke = $paramsApolo['BROKE'];
        
        $this->queueConnection = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);
        
        parent::__construct($this->queueConnection);
        
        $this->dataSet = $dataSet['ROW'];
        $this->loteLancEvento = array_key_exists('LOTELANCEVENTO', $dataSet) ? $dataSet['LOTELANCEVENTO'] : null;
        $this->nrCalculoFolha = array_key_exists('NRCALCULOFOLHA', $dataSet) ? $dataSet['NRCALCULOFOLHA'] : null;
        $this->nrLoteLancEvento = array_key_exists('NRLOTELANCEVENTO', $dataSet) ? $dataSet['NRLOTELANCEVENTO'] : null;
        $this->_nrOrgTrabalho = $this->hcmParameters->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $this->hcmParameters->getNrOrgPadrao();
        $this->_nrEstruturaTrab = FPA::getEstruturaTrabalho();
        $this->_mesCompetencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia());
        $this->_cdOperador = $this->hcmParameters->getCdoperador();
        $this->_retrocesso = false;
        $this->_parcial = false;
        /* Tipo processamento */
        // $tp_processamento = strtoupper($dataSet['TP_PROCESSAMENTO']);
        // $this->_tp_processamento = $tp_processamento;
        // $this->_buscaDadosFormulario($dataSet);
        $this->return = array();
        // Inicializa::Container($entityManager, $hcmParameters, $this->_dtPagamento);

        // $this->_vinculom = TkDI::getContainer()->vinculom;
    }   
    
    public function importacaoItensLoteFicha(){
        
        $operador = $this->entityManager->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $this->_cdOperador));
        
        $paramsHcmParametros = $this->setParametrosHcm();
        
        $importacaoItensParams = array(
            "NRLOTELANCEVENTO"   => $this->nrLoteLancEvento,
            "CDOPERADOR"         => $this->_cdOperador,
            "DSEMAILOPER"        => $operador->getDsemailoper(),
            "DTMESCOMPETENCIA"   => $this->_mesCompetencia->format('d/m/Y'),
            "NRORG"              => $this->_nrOrgTrabalho,
            "DATASET"            => $this->dataSet,
            "PARAMSHCM"          => $paramsHcmParametros  
        );
        
        $this->sendLoteItens($importacaoItensParams);
        $this->return[] = 'Atenção! Através desta opção, o processo de gravação será realizado em segundo plano. Em breve, a notificação de finalização do processo chegará em seu e-mail. Observação: Normalmente, as importações iniciam-se somente após o horário comercial.';
        return $this->return;
    }
    
    public function exportacaoItensLoteFicha(){
        
        $operador = $this->entityManager->getRepository(Repositories::OPERADOR)->findOneBy(array('cdoperador' => $this->_cdOperador));
        
        $paramsHcmParametros = $this->setParametrosHcm();
        
        $exportacaoItensParams = array(
            "NRCALCULOFOLHA"     => $this->nrCalculoFolha,
            "NRLOTELANCEVENTO"   => $this->nrLoteLancEvento,
            "CDOPERADOR"         => $this->_cdOperador,
            "DSEMAILOPER"        => $operador->getDsemailoper(),
            "DTMESCOMPETENCIA"   => $this->_mesCompetencia->format('d/m/Y'),
            "NRORG"              => $this->_nrOrgTrabalho,
            "DATASET"            => $this->dataSet,
            "PARAMSHCM"          => $paramsHcmParametros  
        );
        
        $this->sendItensCalc($exportacaoItensParams);
        $this->return[] = 'Atenção! Através desta opção, o processo de exportação será realizado em segundo plano. Em breve, a notificação de finalização do processo chegará em seu e-mail. Observação: Normalmente, as exportações iniciam-se somente após o horário comercial.';
        // $this->return[] = $this->sendItensCalc($exportacaoItensParams);
        return $this->return;
    }
    
    public function setParametrosHcm(){
        return array(
            "cdoperador"        => $this->hcmParameters->getCdoperador(),
            "nmoperador"        => $this->hcmParameters->getNmoperador(),
            "nrestruttrab"      => $this->hcmParameters->getEstruturaTrabalho(),
            "nrorgpadrao"       => strval($this->hcmParameters->getNrorgpadrao()),
            "nrorg"             => strval($this->hcmParameters->getNrorg()),
            "nrorgtrab"         => strval($this->hcmParameters->getNrorgTrabalho()),
            "dtmescompetenc"    => $this->hcmParameters->getDtCompetencia(),
            "dtmescompetencdiacorrente" => $this->hcmParameters->getPrimeiroDiaDoMes(),
            "nrtipoestrutlegal" => $this->hcmParameters->getTipoEstruturaLegalOrg(),
            "nrtipoestrutgeren" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "idambientesal"     => $this->hcmParameters->getIdambientesal(),
            "nrocorrecal"       => $this->hcmParameters->getOcorrenciaCalculo(),
            "nrtpmodalidcal"    => $this->hcmParameters->getNrModalidadeCalculo(),
            "nrtpmodalidsal"    => $this->hcmParameters->getNrModalidadeSalario(),
            "dataatual"         => DateUtil::getDataAtual(),
            "dtultimodiames"    => $this->hcmParameters->getUltimoDiaMes(),
            "dtultimodiacompetencia" => $this->hcmParameters->getDtmescomptencDiaCorrente(),
        );
    }
    
    public function sendLoteItens($importacaoItensParams){
        $dtatual = DateUtil::getDataAtual();
        $horaDisparo = $dtatual->format('H:i:s');
        $this->horaDisparo = str_replace(':','',$horaDisparo);
        $this->horaDisparo = 'migFicha' . $this->horaDisparo;
        self::$queueName .= 'hcm_migracaoFichaFinanceira_'.$this->_nrOrgTrabalho.$this->horaDisparo;

        $count    = 0;
        $itens = array();
        $params   = $importacaoItensParams;

        $qtItens = count($importacaoItensParams["DATASET"]);
        
        $limiteLote = $qtItens / self::LIMIT_LOTE_ONE;
        
        
        //Inicializa Consumidores e aguarda 20 segundos para os mesmos estarem em execução.
        $this->inicializaConsumidorJenkins($importacaoItensParams);
        sleep(20);

        if ($qtItens > $limiteLote) {
            foreach ($importacaoItensParams["DATASET"] as $key => $item) {
                if ($count < $limiteLote) {
                    $itens[$key] = $item;
                    $count++;
                } else {
                    $params["DATASET"] = $itens;
                    $message = json_encode(array(
                            'IMPORTACAO_PARAMS' => array(
                                $params
                            )
                        )
                    );

                    $this->send($message);
                    $itens = array();
                    $itens[$key] = $item; // o vinculo que faz entrar no 'else' não é contemplado no array, então zeramos adicionando ele para o próximo
                    $count = 1; // como adicionamos o vínculo acima, o contador deve iniciar com zero.
                }
            }
        } else {
            $itens = $importacaoItensParams["DATASET"];
        }

        if (count($itens) > 0) {
            $params["DATASET"] = $itens;
            $message = json_encode(array(
                    'IMPORTACAO_PARAMS' => array(
                        $params
                    )
                )
            );
            $this->send($message);
        }
    }
    
    public function sendItensCalc($exportacaoItensParams){
        $dtatual = DateUtil::getDataAtual();
        $horaDisparo = $dtatual->format('H:i:s');
        $this->horaDisparo = str_replace(':','',$horaDisparo);
        $this->horaDisparo = 'expFicha' . $this->horaDisparo;
        self::$queueName .= 'hcm_exportacaoFichaFinanceira_'.$this->_nrOrgTrabalho.$this->horaDisparo;
        
        $count    = 0;
        $itens = array();
        $params   = $exportacaoItensParams;

        $qtItens = count($exportacaoItensParams["DATASET"]);
        $limiteLote = $qtItens / self::LIMIT_LOTE_ONE;
        
        
        //Inicializa Consumidores e aguarda 20 segundos para os mesmos estarem em execução.
        $this->inicializaConsumidorJenkins($exportacaoItensParams);
        sleep(20);
        
        if ($qtItens > $limiteLote) {
            foreach ($exportacaoItensParams["DATASET"] as $key => $item) {
                if ($count < $limiteLote) {
                    $itens[$key] = $item->getNritlotelanc();
                    $count++;
                } else {
                    $params["DATASET"] = $itens;
                    $message = json_encode(array(
                            'EXPORTACAO_PARAMS' => array(
                                $params
                            )
                        )
                    );

                    $this->send($message);
                    $itens = array();
                    $itens[$key] = $item->getNritlotelanc(); // o vinculo que faz entrar no 'else' não é contemplado no array, então zeramos adicionando ele para o próximo
                    $count = 1; // como adicionamos o vínculo acima, o contador deve iniciar com zero.
                }
            }
        } else {
            $itens = $exportacaoItensParams["DATASET"];
        }
        if (count($itens) > 0) {
            $data = [];
            foreach($itens as $key => $item){
                $data[$key] = $item->getNritlotelanc();
            }
            $params["DATASET"] = $data;
            $message = json_encode(array(
                    'EXPORTACAO_PARAMS' => array(
                        $params
                    )
                )                                                                                                                                                                                                  
            );
            // Rotina para enviar para o Apollo
            $this->send($message);
            
            // Rotina para testar o envio quando o Apollo não funciona
            // $retorno = $this->consume($message);
            // return $retorno;
        }
    }
    
    private function inicializaConsumidorJenkins($importacaoItensParams) {
        $url = $this->hcmParameters->getUrlJenkinsMobileOneConsumer($this->horaDisparo);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_exec($ch);
        $requestInfo = curl_getinfo($ch);
        if ($requestInfo['http_code'] !== 201) {
            throw new \Exception('Não foi possível inicializar o consumidor via Jenkis, favor verificar, código: '.$requestInfo['http_code']);
        }
    }
    
    // funcao para teste da rotina
    // public function consume($message) {        
    // 	try {
    // 	    $mensagem = '';
            
    //         $consumerParams = json_decode($message, true);
    //         $exportacaoItensParams  = $consumerParams['EXPORTACAO_PARAMS'][0];
            
    //         $this->dataSet           = $exportacaoItensParams["DATASET"];
    //         $this->dsemailoper       = $exportacaoItensParams["DSEMAILOPER"];
    //         $this->cdoperador        = $exportacaoItensParams["CDOPERADOR"];
    //         $this->dtmescompetencia  = $exportacaoItensParams["DTMESCOMPETENCIA"];
    //         $this->nrorg             = $exportacaoItensParams["NRORG"];
    //         $this->nrCalculoFolha    = $exportacaoItensParams['NRCALCULOFOLHA'];
    //         $this->nrLoteLancEvento  = $exportacaoItensParams['NRLOTELANCEVENTO'];
            
            
    //         $this->calculoFolha   = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->findOneBy(array('nrorg' => $this->nrorg, 'nrcalculofolha' => $this->nrCalculoFolha));
    //         $this->loteLancEvento = $this->entityManager->getRepository(Repositories::FPA_LOTELANCEVENTO)->findOneBy(array('nrorg' => $this->nrorg, 'nrlotelancevento' => $this->nrLoteLancEvento));
            
    //         $nritens = '';
    //         $countItens = 0;
            
            
    //         foreach($this->dataSet as $nritlotelanc){
    //             $iteLoteLanc = $this->entityManager->getRepository(Repositories::FPA_ITEMLOTELANC)->findOneBy(array('nrorg' => $this->nrorg, 'nritlotelanc' => $nritlotelanc, 'nrlotelancevento' => $this->nrLoteLancEvento));
    //             $evento = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento($iteLoteLanc->getNreventom(), $this->nrorg, $this->hcmParameters->getNrOrgPadrao(), $this->dtmescompetencia);
                
    //             $novoItem = $this->novoItemCalcFolha($this->nrorg, $iteLoteLanc->getNrvinculom(), $iteLoteLanc->getNreventom(), $this->nrCalculoFolha, $this->nrLoteLancEvento, DateUtil::getDataDeString($iteLoteLanc->getDtocorrencia(), DateUtil::FORMATO_BRASILEIRO,
    //                                                  true), $evento->historico->getIdeventodemonst(), $iteLoteLanc->getVreventolote(), $iteLoteLanc->getVrreffolhalote(), 'REFERENCIA_VALOR', $iteLoteLanc->getDsobservacao());
    //             $nritens .= $novoItem->getNritemcalcfolha().","; 
    //             $countItens++;
    //         }
            
    //         $mensagem .= "Itens adicionados ".$nritens." no cálculo ".$this->nrCalculoFolha." do lote ".$this->nrLoteLancEvento.".";
    //         // Define parametros do operador.
    //         // $this->showAmbiente();
             
    //         if (count($this->dataSet) == $countItens){
    //             $this->loteLancEvento->setIdstatuslotelanc('APROVADO');
    //             $this->entityManager->persist($this->loteLancEvento);
    //             $this->entityManager->flush();
    //         }
    
    //         // $this->entityManager->commit();
    //         return $mensagem;
    //         //Envia email para o operador informando o término do calculo.
    //         // $this->notificaMigracao($resultado, $nritens);
    //         // $pid = explode(',', $calculoConsumer[0]['DSPIDPROCESSO']);
    //         // return array(true, $this->pid, array_unique($pid));
            
    //     } catch (\Exception $e) {
    //         $this->entityManager->rollback();
    //         // echo "Erro: ".$e->getMessage();
    //         throw $e;
    //         // $this->kill($this->pid);
    //         // die();
    //     }
    // }
    
    // public function novoItemCalcFolha($nrorg, $nrvinculom, $nreventom, $nrcalculofolha, $nrlotelancevento, $dtocorrencia, $idevendemoncalc, $vreventofolha, $vrreffolha, $idrefevalorcalc, $dsitemcalcfolha = null, $dtgerultcnab = null, $qtocorproxperi = null, 
    //                                   $vrvelho = null, $nrgozoferias = null){
    //     $fpa_itecalcfolha = Repositories::FPA_ITECALCFOLHA;
    //     $item = new $fpa_itecalcfolha;
        
    //     $item->setNrorg($nrorg);
    //     $item->setNrvinculom($nrvinculom);
    //     $item->setNreventom($nreventom);
    //     $item->setNrcalculofolha($nrcalculofolha);
    //     $item->setNrlotelancevento($nrlotelancevento);
    //     $item->setDtocorrencia($dtocorrencia);
    //     $item->setIdevendemoncalc($idevendemoncalc);
    //     $item->setVreventofolha($vreventofolha);
    //     $item->setVrreffolha($vrreffolha);
    //     $item->setDsitemcalcfolha($dsitemcalcfolha);
    //     $item->setDtgerultcnab($dtgerultcnab);
    //     $item->setIdrefevalorcalc($idrefevalorcalc);
    //     $item->setQtocorproxperi($qtocorproxperi);
    //     $item->setVrvelho($vrvelho);
    //     $item->setNrgozoferias($nrgozoferias);
        
        
    //     $item->setDtinclusao(DateUtil::getDataAtual());
    //     $item->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
    //     $item->setCdoperinclusao($this->hcmParameters->getCdoperador());
    //     $item->setDtultatu(DateUtil::getDataAtual());
    //     $item->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
    //     $item->setCdoperultatu($this->hcmParameters->getCdoperador());
        
    //     $item->setNritemcalcfolha(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_ITECALCFOLHA', 1, 12, true));
        
    //     $this->entityManager->persist($item);
    //     $this->entityManager->flush();
    //     return $item; 
    // }
}