<?php

namespace HCM\Geral\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;

class CboRepository
{
    private $entityManager;
    private $hcmParameters;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters)
    {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function findCboPorNumero(Int $nrCbo): ?object
    {
        $params = array(
            'nrorg' => array(
                $this->hcmParameters->getNrorgPadrao(),
                $this->hcmParameters->getNrorgTrabalho()
            ),
            'nrcbo' => $nrCbo
        );

        return $this->entityManager->getRepository(Repositories::GPE_CBO)->findOneBy($params);
    }
}