<?php

namespace HCM\PTO\Logic\AFD;

/**
 * Manipulador de informacoes. Responsavel por armazenar os parametros para a exportacao
 * 
 * 
 */

abstract class Manipulador {
    /** @var \Doctrine\ORM\EntityManager */
    private $entityManager;
    /** @var Parametro */
    private $parametros;
    
    public function __construct(\Doctrine\ORM\EntityManager $entityManager, Parametros $parametros) {
        $this->entityManager = $entityManager;
        $this->parametros = $parametros;
    }
    
    /**
     * Retorna os parametros atuais
     * @return Parametro
     */
    public function getParametros(): Parametros {
        return $this->parametros;
    }
    
    /**
     * Retorna a entidade de manipulacao de dados
     * @return \Doctrine\ORM\EntityManager
     */
    public function getEntityManager(): \Doctrine\ORM\EntityManager {
        return $this->entityManager;
    }
}