CREATE OR REPLACE TRIGGER USR_ATU_AUTOFORNE_SAP
BEFORE UPDATE OR DELETE OF VRTOTALAF, IDBAIXAAF
   ON AUTOFORNE FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_NRINSJURFORN VARCHAR2(20);
  V_NRAUTOFORN   VARCHAR2(10);
  V_USR_SAP_AF_IDINTERFACE NUMBER;
BEGIN
   IF :NEW.IDTIPOLANCAF = 'A' THEN
      BEGIN
         SELECT NRINSJURFORN
           INTO V_NRINSJURFORN
           FROM FORNECEDOR
          WHERE CDFORNECED       = NVL(:NEW.CDFORNECED,:OLD.CDFORNECED)
            AND NVL(USR_INTEGRAMESAP, 'N') = 'S';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRINSJURFORN := NULL;
      END;

      IF V_NRINSJURFORN IS NOT NULL THEN
         WEBTUNNING(V_DSREMOTEADDR,
                    V_DSREMOTEHOST,
                    V_DSSERVERRDM,
                    V_DSSERVMETHOD,
                    V_DSREMOTEOPER);
         IF UPDATING THEN
            /*MODIFICAO DE AF NA TELA DE ALTERAAO/APROVAO DE AF*/
            IF SUBSTR(V_DSSERVMETHOD, 1, 6) = 'UpdItm' THEN
               :NEW.USR_IDINTEGRAMESAP  := 'S';
               :NEW.USR_TPINTERFACE_SAP := 'A';
            END IF;
            /*CONCLUSO DE ANLISE*/
            IF (((SUBSTR(V_DSSERVMETHOD, 1, 12) = 'getFornEnvia') AND ((:OLD.IDBAIXAAF = '6') AND (NVL(:NEW.IDBAIXAAF, '7') = '7')))OR
                ((SUBSTR(V_DSSERVMETHOD, 1, 10) = 'Conclui_AF') AND  (NVL(:NEW.IDBAIXAAF, '1') = '1')))THEN
               :NEW.USR_IDINTEGRAMESAP  := 'S';
               :NEW.USR_TPINTERFACE_SAP := 'A';
               UPDATE ITEMAUTF
                  SET USR_IDINTEGRAMESAP  = 'S'
                WHERE ITEMAUTF.NRAUTOFORN = NVL(:OLD.NRAUTOFORN, :NEW.NRAUTOFORN)
                  AND ITEMAUTF.CDFILDEST  = NVL(:OLD.CDFILDEST, :NEW.CDFILDEST)
                  AND ITEMAUTF.CDFILLANC  = NVL(:OLD.CDFILLANC, :NEW.CDFILLANC);
            END IF;
            IF SUBSTR(V_DSSERVMETHOD, 1, 8) = 'FecharAF' THEN
               /*CANCELAMENTO DE ENCERRAMENTO DE AF*/
               IF (:NEW.IDBAIXAAF IN ('5', '4') AND (NVL(:OLD.IDBAIXAAF, '1') = '1')) THEN
                  :NEW.USR_TPINTERFACE_SAP := 'A';
                  :NEW.USR_IDINTEGRAMESAP  := 'S';
               END IF;
            END IF;
         END IF;
         IF (DELETING) AND (SUBSTR(V_DSSERVMETHOD, 1, 6) = 'UpdItm') THEN
            SELECT NVL(MAX(IDENTIFIC), '0')
              INTO V_NRAUTOFORN
              FROM USR_SAP_AUTOFORNE
             WHERE IDENTIFIC = :OLD.NRAUTOFORN
               AND CENTRO    = :OLD.CDFILDEST;
            V_USR_SAP_AF_IDINTERFACE := USR_SAP_AF_IDINTERFACE.NEXTVAL;
            IF V_NRAUTOFORN = :OLD.NRAUTOFORN THEN
               INSERT INTO USR_SAP_AUTOFORNE(ALTERACAO, IDENTIFIC, RESUMO,
                                             CENTRO, FORNECEDORCLIENTE, DTAUTOFORN, TAG, LOGIN,
                                             IDTPFORPGTAF, IDTIPOEMITAF, EMPRESA, NRPARCPGTOAF,
                                             NRDIAPGFIXAF, IDUTDIAPGTAF, VRTOTALAF, IDBAIXAAF, IDBAIXAFSAI,
                                             IDAFEXPIRADA, CANCELADO, IDINTERFACE, TPINTERFACE, DTINTERFACEORI,
                                             DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO)
                    VALUES ('T', :OLD.NRAUTOFORN, :OLD.NRAUTOFORN,
                            :OLD.CDFILDEST, V_NRINSJURFORN, :OLD.DTAUTOFORN, :OLD.CDOPERADOR, :OLD.CDOPERADOR,
                            :OLD.IDTPFORPGTAF, :OLD.IDTIPOEMITAF, :OLD.CDEMPRESA, :OLD.NRPARCPGTOAF,
                            :OLD.NRDIAPGFIXAF, :OLD.IDUTDIAPGTAF, :OLD.VRTOTALAF, :OLD.IDBAIXAAF, :OLD.IDBAIXAFSAI,
                            :OLD.IDAFEXPIRADA, 'S', V_USR_SAP_AF_IDINTERFACE, 'E', SYSDATE,
                            NULL, 1, 1, 4);
               UPDATE ITEMAUTF
                  SET USR_IDINTEGRAMESAP = 'S'
                WHERE CDFILDEST  = :OLD.CDFILDEST
                  AND CDFILLANC  = :OLD.CDFILLANC
                  AND NRAUTOFORN = :OLD.NRAUTOFORN;
               USR_EXPO_ITEMAUTF_SAP('INC', :OLD.NRAUTOFORN, V_USR_SAP_AF_IDINTERFACE);
            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_AUTOFORNE_SAP','6.02.XXX'); END;
/